For AI agents: a documentation index is available at the root level at /llms.txt and /llms-full.txt. Append /llms.txt to any URL for a page-level index, or .md for the markdown version of any page.
Dev Portal
DocsAPI ReferenceLearnCommunityChangelog
DocsAPI ReferenceLearnCommunityChangelog
    • About Our APIs
  • REST
    • Overview
      • Overview
        • Brands
        • Categories
        • Category Trees
        • Products
            • GETList Products
            • PUTUpdate Products (batch)
            • POSTCreate Product
            • DELDelete Products
            • GETGet Product
            • PUTUpdate Product
            • DELDelete Product
              • GETList Product Metafields
              • POSTCreate Multiple Metafields
              • PUTUpdate Multiple Metafields
              • DELDelete Multiple Metafields
        • Product Modifiers
        • Product Variants
        • Product Variant Options
      • Payments
  • GraphQL
    • Overview
  • MCP
    • Overview
Dev Portal
LogoLogo
RESTAdminCatalogProductsBatch Metafields

Create Multiple Metafields

POST
https://api.bigcommerce.com/stores/:store_hash/v3/catalog/products/metafields
POST
/stores/:store_hash/v3/catalog/products/metafields
$curl -X POST https://api.bigcommerce.com/stores/store_hash/v3/catalog/products/metafields \
> -H "X-Auth-Token: <apiKey>" \
> -H "Content-Type: application/json" \
> -d '[
> {
> "permission_set": "app_only",
> "namespace": "Inventory Namespace",
> "key": "location_id",
> "value": "Shelf 3, Bin 5",
> "resource_id": 42,
> "description": "Where products are located"
> }
>]'
1{
2 "data": [
3 {
4 "permission_set": "app_only",
5 "namespace": "Sales Department",
6 "key": "Staff Name",
7 "value": "Ronaldo",
8 "description": "order",
9 "resource_type": "cart",
10 "resource_id": 424242,
11 "id": 1,
12 "date_created": "2022-06-16T18:39:00+00:00",
13 "date_modified": "2022-06-16T18:39:00+00:00",
14 "owner_client_id": "asdfasdfasdfasdfasdfasdfasdf"
15 }
16 ],
17 "errors": [],
18 "meta": {
19 "total": 3,
20 "success": 3,
21 "failed": 0
22 }
23}
Create multiple metafields.
Was this page helpful?
Previous

List Product Metafields

Next

Update Multiple Metafields

Built with

Authentication

X-Auth-Tokenstring
### OAuth scopes | UI Name | Permission | Parameter | |:--------|:-----------|:----------| | Products | modify | `store_v2_products` | | Products | read-only | `store_v2_products_read_only` | ### Authentication header | Header | Argument | Description | |:-------|:---------|:------------| | `X-Auth-Token` | `access_token` | For more about API accounts that generate `access_token`s, see our [Guide to API Accounts](/developer/docs/overview/api-fundamentals/api-accounts#api-accounts). | ### Further reading For example requests and more information about authenticating BigCommerce APIs, see [Authentication and Example Requests](/developer/docs/overview/api-fundamentals/api-accounts#x-auth-token-header-example-requests). For more about BigCommerce OAuth scopes, see our [Guide to API Accounts](/developer/docs/overview/api-fundamentals/api-accounts#oauth-scopes). For a list of API status codes, see [API Status Codes](/developer/api-reference/rest/overview#rest-http-status-codes).

Path parameters

store_hashstringRequired
Permanent ID of the BigCommerce store.

Request

permission_setenumRequired

Determines the visibility and writeability of the field by other API consumers.

ValueDescription
app_onlyPrivate to the app that owns the field.
readVisible to other API consumers.
writeOpen for reading and writing by other API consumers.
read_and_sf_accessVisible to other API consumers, including on the storefront.
write_and_sf_accessOpen for reading and writing by other API consumers, including on the storefront.
Allowed values:
namespacestringRequired1-64 characters
Namespace for the metafield, for organizational purposes.
keystringRequired1-64 characters

The name of the field, for example: location_id, color.

valuestringRequired1-65535 characters

The value of the field, for example: 1, blue.

resource_idintegerRequired
The ID for the product with which the metafield is associated.
descriptionstringOptional0-255 characters
Description for the metafields.

Response

List of created Metafield objects.

datalist of objects
errorslist of any
Empty for 200 responses.
metaobject
Additional data about the response.

Errors

400
Bad Request Error
422
Unprocessable Entity Error

OAuth scopes

UI NamePermissionParameter
Productsmodifystore_v2_products
Productsread-onlystore_v2_products_read_only

Authentication header

HeaderArgumentDescription
X-Auth-Tokenaccess_tokenFor more about API accounts that generate access_tokens, see our Guide to API Accounts.

Further reading

For example requests and more information about authenticating BigCommerce APIs, see Authentication and Example Requests.

For more about BigCommerce OAuth scopes, see our Guide to API Accounts.

For a list of API status codes, see API Status Codes.